#!/usr/bin/perl

use strict;

# Path to SSH
my $ssh = "/usr/bin/ssh";

if ($#ARGV < 0)
{
   print "Usage: map_flogi.pl \"switch\"\n";
   exit();
}


my $switch = $ARGV[0];

my $cmd = "show int |inc up |inc fc";
my $arg = "|include up |inc fc"; 

my @ports = get_all_ports($switch);

for my $port (@ports)
{
   my @returns = find_wwn_on_port($switch, $port);
   foreach my $wwn (@returns)
   {
      my @zones = s_find_zones($switch, $wwn);
      foreach my $zone (@zones)
      {
         print "$switch,$port,$wwn,$zone\n";
      }
   }
}

sub get_all_ports {

my ($switch) = @_;

my $cmd = "show int |inc up |inc fc";
my $arg = "|include up |inc fc";

my @returns;

my $command = "$ssh $switch \"$cmd $arg\"";
open (OUTPUT, "$command 2>/dev/null|") || die "Can't open: $command: $!\n\n";
while (<OUTPUT>)
{
   chomp;
   if ($_ =~ /^fc/)
   {
    my @data = split(" ", $_);
    push(@returns, $data[0]);
   }
}

return @returns;

}

sub find_wwn_on_port {
   my ($switch, $port) = @_;
   my $cmd = "show flogi database interface ";
   my $arg= "$port |inc $port |cut -c 34-56";
   my $command = "$ssh $switch \"$cmd $arg\"";
   my @returns;
   open (OUTPUT, "$command 2>/dev/null |") || die "Can't open: $command: $!\n\n";
   while (<OUTPUT>)
   {
      chomp;
      s/\s+/ /g;
      push(@returns, $_);
   }

   return @returns;
}

sub s_find_zones {
   my ($switch, $wwn) = @_;

   my @results;
   my $cmd = "show zone member pwwn";
   my $arg = " $wwn";
   my $command = "$ssh $switch \"$cmd $arg\"";
   open (OUTPUT, "$command 2>/dev/null |") || die "Can't open: $command: $!\n\n";
   while (<OUTPUT>)
   {
      chomp;
      my $host;
      if ($_ =~ /  zone/)
      {
         my ($junk, $zone) = split(" ", $_);
         ##### If you want to do some parsing of your zone name to return some vudo,  you can.
         ##
         ## Just push the results
         push(@results, $zone);
      }
   }
   my @unique = uniq(@results);
   return @unique;
}

sub uniq {local %_; grep {!$_{$_}++} @_}
